config/routes.rb
Rails.application.routes.draw do
  # get 'search/people'
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  root 'home#index'
  get 'home/index'

  resources :community_surveys do
    resources :houses do
      resources :family_folders do
        resources :house_health_surveys
        get '/people/search/:id', to: 'people#search'
        resources :people do
          resources :person_health_surveys
          resources :home_visits
        end
      end
    end
  end

  # Address
  get 'addr/update_amphur/:id', to: 'addresses#update_amphur'
  get 'addr/update_tambon/:id', to: 'addresses#update_tambon'

  # Authentication
  get '/login', to: 'sessions#new'
  post '/login', to: 'sessions#create'
  delete '/logout', to: 'sessions#destroy'

  get '/goto_house', to: 'home#house'
  get '/goto_house_health_survey', to: 'home#house_health_survey'
  get '/goto_person', to: 'home#person'
  get '/goto_person_health_survey', to: 'home#person_health_survey'
  get '/goto_home_visit', to: 'home#home_visit'

  get 'communities/search', to: 'community_surveys#search_main'
  resources :diseases

  # Report
  # resources :reports
  # get '/reports', to: 'reports#community_survey'
  get '/reports/overall', to: 'reports#overall'
  get '/reports/community', to: 'reports#community_survey'
  get '/reports/admin/health_survey', to: 'reports#admin_health_survey'
  get '/reports/admin/home_visit', to: 'reports#admin_home_visit'
  get '/reports/admin/houses', to: 'reports#admin_houses'
  get '/reports/admin/people', to: 'reports#admin_people'
  get '/reports/site/health_survey', to: 'reports#site_health_survey'
  get '/reports/site/home_visit', to: 'reports#site_home_visit'
  get '/reports/site/houses', to: 'reports#site_houses'
  get '/reports/site/people', to: 'reports#site_people'

  get '/hospitals', to: 'hospitals#search'
  get '/hospitals/type/:id', to: 'hospitals#by_type'

  # Search
  # get '/search', to: 'search#search_people'
  # Test
  get '/search', to: 'search#people'
end

app/controllers/houses_controller.rb
class HousesController < ApplicationController
  include AddressHelper
  before_action :set_community_survey
  before_action :set_house, only: [:show, :edit, :update, :destroy]

  # GET /houses
  # GET /houses.json
  def index
    respond_to do |format|
      format.html do
        @houses = House.where(community_survey: @community_survey).order(created_at: :desc).page(page_param)
        @houses = @houses.filter_by_hid(params[:hid]) if params[:hid].present?
        render :index
      end
      format.json do
        @houses = House.where(community_survey: @community_survey).order(created_at: :desc)
        houses = @houses.map { |h| [h.short, h.hid] }
        label = houses.empty? ? t(:no_data_label) : t(:please_select_label)
        houses = houses.unshift([label, '""'])
        render json: houses, status: :ok
      end
    end
  end

  # GET /houses/1
  # GET /houses/1.json
  def show
    @family_folders = FamilyFolder.where(house: @house)
    load_addr @house
  end

  # GET /houses/new
  def new
    @house = House.new addr_changwat_id: @community_survey.addr_changwat_id,
                       addr_amphur_id: @community_survey.addr_amphur_id, addr_tambon_id: @community_survey.addr_tambon_id
    load_addr @house
  end

  # GET /houses/1/edit
  def edit
    load_addr @house
    # @external = true if request.referer && request.referer.include?('family_folders')
  end

  # POST /houses
  # POST /houses.json
  def create
    tambon = AddrTambon.find(house_params.fetch(:addr_tambon_id))
    @house = House.new(house_params.merge(catm: "#{tambon.code}00"))

    respond_to do |format|
      if @house.save
        timestamp = Time.now
        logger.info "[FF] House [#{@house.id}] created by #{current_user.username} at #{timestamp}"
        AuditLog.create user: current_user.username, category: 'HOUSE', action: "created [#{@house.id}] at #{timestamp}"
        # Create Family Folder
        ff = FamilyFolder.create house: @house, hospcode: current_user.hospcode
        AuditLog.create user: current_user.username, category: 'FAMILY_FOLDER', action: "created [#{ff.id}] at #{timestamp}"
        format.html do
          redirect_to community_survey_house_path(@community_survey, @house),
                      notice: t('house.m_created_label')
        end
        format.json { render :show, status: :created, location: @house }
      else
        load_addr @house
        format.html { render :new }
        format.json { render json: @house.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /houses/1
  # PATCH/PUT /houses/1.json
  def update
    respond_to do |format|
      if @house.update(house_params)
        timestamp = Time.now
        logger.info "[FF] House [#{@house.id}] updated by #{current_user.username} at #{timestamp}"
        AuditLog.create user: current_user.username, category: 'HOUSE', action: "updated [#{@house.id}] at #{timestamp}"
        format.html do
          redirect_to community_survey_house_path(@community_survey, @house),
                      notice: t('house.m_updated_label')
        end
        format.json { render :show, status: :ok, location: @house }
      else
        load_addr @house
        format.html { render :edit }
        format.json { render json: @house.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /houses/1
  # DELETE /houses/1.json
  def destroy
    timestamp = Time.now
    @house.destroy
    logger.info "[FF] House [#{@house.id}] destroyed by #{current_user.username} at #{timestamp}"
    AuditLog.create user: current_user.username, category: 'HOUSE', action: "destroyed [#{@house.id}] at #{timestamp}"
    respond_to do |format|
      format.html do
        redirect_to community_survey_houses_path(@community_survey),
                    notice: t('house.m_deleted_label')
      end
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_house
    @house = House.find(params[:id])
  end

  def set_community_survey
    @community_survey = CommunitySurvey.find(params[:community_survey_id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def house_params
    datesurvey_param = params.fetch(:house, {}).fetch(:datesurvey)
    params.fetch(:house, {}).merge(hospcode: current_user.hospcode,
                                   community_survey: @community_survey,
                                   datesurvey: convert_buddhist_year_to_gregorian_year(datesurvey_param)).permit!
  end
end

app/helpers/houses_helper.rb
module HousesHelper
  def house_style_value(value)
    return t(:not_found_label) if value.nil?
    hs_value = House.house_style_types.invert.fetch(value.to_i)
    t("house.housestyletype_#{hs_value}_label")
  end
end

app/views/houses/edit.html.erb
<%= render 'form', community_survey: @community_survey, house: @house %>
<% content_for :menu_content_title do %>
  <div><%= t 'house.edit_label' %></div>
<% end %>

app/views/houses/index.html.erb
<div class="container">
  <% unless notice.nil? %>
    <div id="notice">
      <div class="ui message icon">
        <i class="close icon"></i>
        <i class="info circle icon"></i>
        <div class="content">
          <%= notice %>
        </div>
      </div>
    </div>
  <% end %>

  <% unless @houses.empty? %>
    <table class="ui table unstackable --responsive">
      <thead>
        <tr>
          <th class="center aligned"><%= t :no_label %></th>
          <th class="center aligned"><%= t 'house.hid_label' %></th>
          <th class="center aligned"><%= t 'house.namesurvey_label' %></th>
          <th class="center aligned"><%= t 'house.positionsurvey_label' %></th>
          <th class="center aligned"><%= t 'house.house_label' %></th>
          <th class="center aligned"><%= t 'house.housestyletype_label' %></th>
          <th class="center aligned"><%= t 'house.datesurvey_label' %></th>
          <th class="center aligned"><%= t 'house.u_date' %></th>
          <th colspan="3" class="center aligned"><%= t :actions_label %></th>
        </tr>
      </thead>
      <tbody>
        <% @houses.each_with_index do |house, index| %>
          <tr>
            <td class="center aligned" data-label="<%= t :no_label %>"><%= no(@houses) + index %></td>
            <td class="center aligned" data-label="<%= t 'house.hid_label' %>"><%= house.hid %></td>
            <td data-label="<%= t 'house.namesurvey_label' %>"><%= house.namesurvey %></td>
            <td data-label="<%= t 'house.positionsurvey_label' %>"><%= house.positionsurvey %></td>
            <td data-label="<%= t 'house.house_label' %>"><%= house.house %></td>
            <td data-label="<%= t 'house.housestyletype_label' %>"><%= house_style_value(house.housestyletype) %></td>
            <td class="center aligned" data-label="<%= t 'house.datesurvey_label' %>"><%= date_format(house.datesurvey) %></td>
            <td class="center aligned" data-label="<%= t 'house.u_date' %>"><%= date_time_format(house.u_date) %></td>
            <td class="action" data-label="<%= t :actions_label %>">
              <%= link_to  community_survey_house_path(@community_survey, house), data: { tooltip: t('info_label'), position: "bottom left" }, class: "ui button --circle --submit" do %>
                <i class="info icon"></i>
              <% end %>
              <%= link_to community_survey_house_family_folders_path(@community_survey, house), data: { tooltip: t('family_folder.title_label'), position: "bottom left" }, class: "ui button --circle --submit" do %>
                <i class="ico-next-alt"></i>
              <% end %>
              <%= link_to edit_community_survey_house_path(@community_survey, house), data: { tooltip: t('edit_label'), position: "bottom left" }, class: "ui button --circle --submit" do %>
                <i class="ico-edit"></i>
              <% end %>
              <%= link_to community_survey_house_path(@community_survey, house), method: :delete, data: { confirm: t(:confirm_delete_label), tooltip: t('destroy_label'), position: "bottom right" }, class: "ui button --circle --submit" do %>
                <i class="ico-bin"></i>
              <% end %>
            </td>
          </tr>
        <% end %>
      </tbody>
    </table>
    <div class="pagination">
      <%= paginate @houses %>
    </div>
  <% else %>
    <div class="container__no-content">
      <div>
        <div class="container__no-content --icon">
          <i class="file outline icon"></i>
        </div>
        <div class="container__no-content --text"><%= t('house.title_label_not_found') %></div>
        <div class="container__no-content --button">
          <%= link_to new_community_survey_house_path, class: "ui button --icon-only" do %>
            <%= t 'house.add_label' %>
          <% end %>
        </div>
      </div>
    </div>
  <% end %>
</div>
<% content_for :menu_content_title do %>
  <div class="menuFilter-contentLeft__button">
    <button id="toggle_breadcrumb" class="ui button active --toggle">
      <i id="toggle_breadcrumb_icon" class="ellipsis vertical icon"></i>
    </button>
  </div>
  <div class="ui breadcrumb">
    <% if params[:hid].present? %>
      <%= link_to community_surveys_path(vid: params[:community_survey_id], value: params[:value]), class: 'section' do %>
        <div class="breadcrumb__label"><%= t('community_survey.title_label') %></div>
        <div class="breadcrumb__content">(<%= @community_survey.vname %>)</div>
      <% end %>
      <i class="right angle icon divider"></i>
      <div class="active section"><%= t 'house.title_label' %></div>

      <% content_for :clear_search do %>
        <%= link_to t("clear_search_label"), community_survey_houses_path(@community_survey), class: "ui button" %>
      <% end %>
    <% else %>
      <%= link_to community_surveys_path, class: 'section' do %>
        <div class="breadcrumb__label"><%= t('community_survey.title_label') %></div>
        <div class="breadcrumb__content">(<%= @community_survey.vname %>)</div>
      <% end %>
      <i class="right angle icon divider"></i>
      <div class="active section"><%= t 'house.title_label' %></div>
    <% end %>
  </div>
<% end %>
<% content_for :menu_content_link do %>
  <%= link_to new_community_survey_house_path, class: "ui button --icon-only", data: { tooltip: t('house.add_label'), position: "left center" } do %>
    <div class="icon-group">
      <i class="ico-add"></i>
      <i class="ico-home"></i>
    </div>
  <% end %>
<% end %>

app/views/houses/new.html.erb
<%= render 'form', community_survey: @community_survey, house: @house %>
<% content_for :menu_content_title do %>
  <div><%= t 'house.add_label' %></div>
<% end %>

app/views/houses/show.html.erb
<% unless notice.nil? %>
  <div id="notice">
    <div class="ui message icon">
      <i class="close icon"></i>
      <i class="info circle icon"></i>
      <div class="content">
        <%= notice %>
      </div>
    </div>
  </div>
<% end %>
<%= render 'houses/info', community_survey: @community_survey, house: @house %>
<% content_for :menu_content_title do %>
  <div><%= t 'house.title_label' %></div>
<% end %>